__doc__ = """\
Project:MOFS 
Start:  Sun Jul 10 04:11:21 MSK 2000
Author: Andrey Orlov  (c) 2002
Version:$Id: CatalogAwareness.py,v 1.23 2002/11/24 19:23:47 cray Exp $

Title:
        MOFS / Z Catalog Modified : Catalog Aware
        
Description :
    
        Some enhancement for use with Reindex as "default
        catalog" : New management views added and some
        functiionality "afterClone" changed.

Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:        
        Allowing versioning usability

"""
__version__ = "$Revision: 1.23 $"
# $Source: /var/lib/cvs/IIGFS/zope/Products/MOFS/CatalogAwareness.py,v $

import urllib, string

import Products.ZCatalog.CatalogPathAwareness
import Products.ZCatalog.ZCatalog
from Globals import default__class_init__

from libIIGFS import *

import l10n
_ = l10n.getL10n_decoder(__file__,'MOFS')
from l10n import DTMLFile

#import Reindex  !!

def filter_reindex(ob) :
        if hasattr(ob,ob.default_catalog) :
#               if isinstance(getattr(ob,ob.default_catalog),Reindex.Reindex) :  !!
                if getattr(ob,ob.default_catalog).meta_type == 'Reindex' :
                        return 1
                elif isinstance(getattr(ob,ob.default_catalog),Products.ZCatalog.ZCatalog.ZCatalog) :
                        return 1
        return 0

class CatalogAware (Products.ZCatalog.CatalogPathAwareness.CatalogAware) :
    _unique_catalog_id = None
    query_length = 10
    __ac_permissions__ = (
        ('View management screens', ()),
        ('View IIGFS managment',    ()),
        ('Change IIGFS',            ('manage_afterClone',)),
        ('View IIGFS',              ('unique_catalog_id','url') ),
        ('Use IIGFS Administrative functions', ( 'manage_reindex_aware_update', 'manage_reindex','manage_reindex_aware',
                                'reindex_aware_find',
                                'reindex_aware_check_and_recovery',
                                ) ),
    ) 
    
    manage_options = (
        {'label': _('Indexing'),        'action': 'manage_reindex_aware', 'filter': filter_reindex},
    )
    
    def unique_catalog_id(self) :
        return self._unique_catalog_id

    def url(self) :
        return self.getPath()

    def manage_afterClone(self, item) :
        self.index_object()
        if hasattr(self, self.default_catalog) :
            if hasattr(getattr(self, self.default_catalog),'recatalog_object') :
                getattr(self, self.default_catalog).recatalog_object(self, self.url())

        for object in self.objectValues():
            try: s=object._p_changed
            except: s=0
            object.manage_afterClone(item)
            if s is None: object._p_deactivate()

    def manage_reindex_aware_update(self,init=0,REQUEST=None) :
        """    """
        self.unindex_object()
        if init :
                self._unique_catalog_id = None
        self.index_object()

        if not (REQUEST is None) :
                return self.manage_reindex_aware(self,REQUEST=REQUEST,RESPONSE=REQUEST.RESPONSE)

        return _('Index changed')

    manage_reindex = DTMLFile('dtml/reindex', globals())
    manage_reindex_aware = DTMLFile('dtml/reindex_awareEdit', globals())

    def reindex_aware_find(self,obs=None) :
        if obs is None :
                obs = []
        for item in self.objectValues() :
                if issubclass(item.__class__,CatalogAware) :
                        obs.append(item)
                        item.reindex_aware_find(obs)
        return obs

    def reindex_aware_check_and_recovery(self,REQUEST) :
        fix = REQUEST.form.has_key('fix')
        if not REQUEST.has_key('start') :
                start = 0
        else :
                start = max(int(REQUEST['start'])-1,0)

        res = []
        record = self.reindex_aware_find()

        try :
                query_length = int(self.request_default('query_length'))
        except ValueError :
                query_length = self.query_length

        record = record[start:query_length+start+1]
        d_init = {}
        d_init['previous-sequence-start-number']          = None
        d_init['next-sequence-start-number']              = None
        if start > 0 :
                d_init['previous-sequence-start-number'] = max(start+1-query_length,1)
        if len(record) > query_length :
                d_init['next-sequence-start-number'] = start + 1 + query_length
        d_init['record_message'] = []


        if len(record) > 1 :
                record = record[0:-1]

        for item in record :
                d = d_init.copy()
                d['record_message'] = []
                d['record_id']     = item.unique_catalog_id() 
                d['record_path']   = item.url()
                d['record_object'] = item

                if REQUEST.form.has_key('check_catalog') :
#                       if isinstance(getattr(self,self.default_catalog),Reindex.Reindex) :  !!
                    if getattr(self,self.default_catalog).meta_type == 'Reindex' :
                                getattr(self, self.default_catalog).get_function('reindex_check_record')(d,item,REQUEST)

                if REQUEST.form.has_key('fix') :
                        item.manage_reindex_aware_update(init=REQUEST.form.has_key('init'))
                        if REQUEST.form.has_key('init') :
                                d['record_message'].append(_('New ID created'))
                        else :
                                d['record_message'].append(_('Object record updated'))

                res.append(d)
        return res

default__class_init__ (CatalogAware)
