__doc__ = """\
Project:IIGFS
Start:  Tue Jan  1 15:16:05 MSK 2002
Author:   (c) 2001
Version:$Id: Factory.py,v 1.17 2002/11/24 19:56:58 cray Exp $

Title:   
        MOFS / Factory

Description:

        Object factory used to create IIGFS objects. Factory do standard
        validation and set some attributes into pre-defined values;

            ,   
           -  ..  
         .

               
        .

        :
        
                Allow_Factory_Id_Override    -  
                         1- 

                Allow_Factory_Id_Override_All -  
                        -  -1 0 

                Allow_Factory_Id_Define    -   id,  id
                          

                0  - ,    SiteRoot

        :

                factory_id_index -      
                          Properties,    
                             
                           ,  
                           .

                factory_notallowedid_except -      
                        ,    
                         ,  
                          ,  
                           ;

                factory_go_into_new_object -     
                        ,     
                           ,  -  
                        ,     
                        ;

                order -      order,  
                            
                        

Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:        
        - Support for use as method, not only as TTW-script;
        
        - Support for isolated using : It means of "without iigfs";

"""
__version__ = "$Revision: 1.17 $"
# $Source: /var/lib/cvs/IIGFS/zope/Products/MOFS/Factory.py,v $

from AccessControl.SecurityManagement import getSecurityManager
import Globals
from Globals import default__class_init__
import l10n
_ = l10n.getL10n_decoder(__file__,'MOFS')
from l10n import HTMLFile
Globals.App.Management.Navigation.manage_IdForm = HTMLFile('dtml/IdForm', globals())

try :
  from libIIGFS import libIIGFS_mixin
except :
  import cgi
  import re

  class libIIGFS_mixin :
    """  ,    """
    def request_filter_keys(self,REQUEST,exclude=(),include=None,use_include=None) :
        """     
        
        REQUEST - c,
        include -    None   use_include   0,  
                       ,
        exclude -      ,
        use_include -   0,   include  
                .  
        """

        if include is None or (use_include==0) :
            include = REQUEST.form.keys()
        else :
            if type(include) is type('') :
                include = (include,)
            include = filter(REQUEST.form.has_key,include)

        if type(exclude) is type('') :
            exclude = (exclude,)
        return filter( lambda x,e=exclude : not (x in e), include)

    def request_filter_hidden(self,REQUEST,exclude=[],include=None,use_include=None) :
        """   ,  request_filter_keys 
            HIDDEN,  .
        request_filter_keys 
        """

        s = ''
        for item in self.request_filter_keys(REQUEST,exclude,include,use_include) :
            v = REQUEST.form[item]
            t = type(v)
            if  t is type(0) :
                s = s + '<input type=hidden name="%s:int" value="%i">' % (item,v)
            elif t is type([]) or t is type(()) :
                for vs in v :
                    s = s + '<input type=hidden name="%s:list" value="%s">' % (item,cgi.escape(str(vs),1))
            else :
                s = s + '<input type=hidden name="%s" value="%s">' % (item,cgi.escape(str(v),1))
        return s

    def request_filter_query(self,REQUEST,exclude=[],include=None,use_include=None) :
        """   query,    ,
         request_filter_keys
        """

        s = ''

        for item in self.request_filter_keys(REQUEST,exclude,include,use_include) :
            v = REQUEST.form[item]
            t = type(v)
            if  t is type(0) :
                s = s + '%s:int=%i&' % (item,v)
            elif t is type([]) or t is type(()) :
                for vs in v :
                    s = s + '%s:list=%s&' % (item,urllib.quote_plus(str(vs)))
            else :
                s = s + '%s=%s&' % (item,urllib.quote_plus(str(v)))

        return s

NotAllowedId = "Not Allowed Id"

def toint(x) :
    try :
        return int(x)
    except :
        return 0

def ordmap(x) :
        if hasattr(x.aq_base,'order') :
                try :
                        return int(x.order)
                except :
                        return 0
        else :
                return 0

def check_key(ob,REQUEST,name,set=None) :
        if REQUEST.form.has_key(name) :
                if set :
                        REQUEST.RESPONSE.setCookie(name,REQUEST.form[name],path='/')
                return REQUEST.form[name]
        elif REQUEST.cookies.has_key(name) :
                return REQUEST.cookies[name]
        elif hasattr(ob,name) :
                return getattr(ob,name)
        else :
                return None
        
Globals.App.Management.Navigation.manage_IdForm = HTMLFile('dtml/IdForm', globals(), check_key=check_key)

import AccessControl.Permission
AccessControl.Permission.registerPermissions( (
        ('Allow Factory Id Override', ()),
        ('Allow Factory Id Override All', ()),
        ('Allow Factory Id Define', ()),
))

manage_NotAllowedId = HTMLFile('dtml/NotAllowedId', globals(), check_key=check_key)


from Acquisition import Explicit, aq_inner, aq_parent
from ComputedAttribute import ComputedAttribute
 
class Factory(libIIGFS_mixin, Explicit ) :
        """   IIGFS """
        __allow_access_to_unprotected_subobjects__=1

        def _get__roles__(self):
             imp = getattr(aq_parent(aq_inner(self)),
                      '%s__roles__' % self.__name__)
             if hasattr(imp, '__of__'):
                      return imp.__of__(self)
             return imp

        __roles__ = ComputedAttribute(_get__roles__, 1)
 
        
        def __init__(self,klass,prefix,name) :
                """  :
                klass -  ,
                prefix - ,    .
                """
                self.klass = klass
                self.prefix = prefix
                self.__name__ = name
                self.__doc__ = " "

        def __call__(self,id=None,REQUEST=None,**kw) :
                """ """
                #context = REQUEST.PARENTS[2]
                context = self.aq_parent
                context = context.aq_parent
                context = context.aq_parent
                sm_check = getSecurityManager().checkPermission

                try :
                        if id and sm_check('Allow_Factory_Id_Define', context) :
                                if sm_check('Allow_Factory_Id_Override_All', context) :         
                                        zero = context.getPhysicalRoot()
                                elif sm_check('Allow_Factory_Id_Override', context) :           
                                        zero = context.getPhysicalRoot()
                                        try :
                                                zero = context.superValues('SiteRoot')[0]
                                        except IndexError :
                                                pass
                                else :
                                        zero = context
                                if hasattr(zero,id) :
                                        raise NotAllowedId
                        else :
                                raise NotAllowedId
                except NotAllowedId :
                        if id and check_key(context,REQUEST,'factory_notallowedid_except',set=1) :
                                raise NotAllowedId,manage_NotAllowedId(self, context, REQUEST, reqid=id, request_filter_hidden = self.request_filter_hidden)

                        if hasattr(context,'factory_id_index') :
                                idx = context.factory_id_index
                                idn = 0
                                try :
                                        idn = getattr(idx,'factory_prefix_%s' % self.prefix) + 1
                                        setattr(idx,'factory_prefix_%s' % self.prefix,idn)
                                except AttributeError :
                                        idx.manage_addProperty('factory_prefix_%s' % self.prefix,0,'int')
                        else :
                                idn = 1+max([0,0] +
                                        map(lambda x,l=len(self.prefix): toint(x[l:]),
                                                filter(lambda x,l=len(self.prefix),p=self.prefix: x[:l] == p,
                                                        context.objectIds()
                                )))

                        if idn == 0 :
                                id = self.prefix
                        else :
                                id = "%s%u" % (self.prefix,idn)


                #      , 
                #   -  -  .

                d = {}
                if REQUEST is not None :
                    d.update(REQUEST.cookies)
                    d.update(REQUEST.form)
                d.update(kw)
                d['id'] = id

                id = d['id'] = apply(self.preinit,(context,REQUEST),d)
                ob = apply(self.klass,(),d)
                id = context._setObject(id, ob)
                ob = context._getOb(id)
                apply(self.postinit,(context,REQUEST,ob),d)

                #   - FactoryDispatcher -   
                #   manage_main

                if REQUEST is not None:
                        if check_key(context,REQUEST,'factory_go_into_new_object',set=1) :
                                REQUEST.RESPONSE.redirect(context.absolute_url() + "/" + id + "/manage_workspace")
                        else :
                                REQUEST.RESPONSE.redirect(context.absolute_url() + "/manage_workspace")

                        return context.manage_main(context, REQUEST)

                return ob

        def postinit(self,context,REQUEST,ob,**kw) :
                """    :    """
                if hasattr(ob,'order') :
                        ob.order=1+max([0,0]+map(ordmap,context.objectValues()))

        def preinit(self,context,REQUEST,id,**kw) : 
                """    :     
                ,         .
                ,       
                 ,      id 
                 -  REQUEST   , ..  REQUEST
                  . """
                return id

