__doc__ = """\
Project:MOFS 
Start:  Sun Jul 10 04:11:21 MSK 2000
Author: Andrey Orlov  (c) 2002
Version:$Id: ObjectManager.py,v 1.20 2002/11/24 19:50:09 cray Exp $

Title:
        MOFS / Object Manager Modified
        
Description :
    
        Mix-In class for objects containers management.  Enhanced by :
        
            - New inline editor allow change properties of included objects;
                
            - List of metatypes are to assigned
                _subobjects_meta_types property;

Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied.
        
TODO:        
        Support for fixed properties;

"""
__version__ = "$Revision: 1.20 $"
# $Source: /var/lib/cvs/IIGFS/zope/Products/MOFS/ObjectManager.py,v $

import ZClasses.ObjectManager
from Globals import default__class_init__
from Globals import MessageDialog
from Acquisition import aq_base, aq_inner, aq_parent
import Products
from OFS.CopySupport import CopyError
from AccessControl.SecurityManagement import getSecurityManager
import l10n
_ = l10n.getL10n_decoder(__file__,'MOFS')
from l10n import DTMLFile
class ObjectManager(ZClasses.ObjectManager.ObjectManager) :
    manage_options = ( # what management options are there?
        {'label': _('Contents'),         'action': 'manage_main'},
    )

    
    __ac_permissions__=(
        ('View management screens', ('manage_main','manage_renameObject','filtered_objectItems')),
	('Manage properties', ('manage_inlineEdit',)),
        ('View full object management', ()),
    )
     

    inline_edit = []

    manage_main=DTMLFile('dtml/content_container', globals())

    def manage_renameObject(self, id, new_id, REQUEST=None):
        """Rename a particular sub-object"""
        try: self._checkId(new_id)
        except: raise CopyError, MessageDialog(
                      title=_('Invalid ID'),
                      message=sys.exc_info()[1],
                      action ='manage_main')
        ob=self._getOb(id)
        if not ob.cb_isMoveable():
            raise CopyError, eNotSupported % id
        self._verifyObjectPaste(ob)
        try:    ob._notifyOfCopyTo(self, op=1)
        except: raise CopyError, MessageDialog(
                      title=_('Rename Error'),
                      message=sys.exc_info()[1],
                      action ='manage_main')
        ob = aq_base(ob)
        self._delObject(id)
        ob._setId(new_id)

        # Note - because a rename always keeps the same context, we
        # can just leave the ownership info unchanged.
        self._setObject(new_id, ob, set_owner=0)

        if REQUEST is not None:
            return self.manage_main(self, REQUEST, update_menu=1)
        return None


    def filtered_objectItems(self,types=None) :
        if getSecurityManager().checkPermission('View full object management', self) :
            return self.objectItems(types)
        else :
            l = self.objectItems(types)
            ls = []
            check = getSecurityManager().checkPermission
            for id,ob in l :
                if check('View management screens',ob) :
                    ls.append((id,ob))
                
            return ls   
#           return self.objectItems(map(lambda x : x['name'],self.filtered_meta_types()))

    def manage_inlineEdit(self,field,REQUEST=None) :
        """     """
        for item in field :
            try :
                ob = getattr(self,item['id'])
            except AttributeError :
                pass
            else :
                for atr,title in self.inline_edit :
                    setattr(ob,atr,getattr(item,atr,""))
            
        if REQUEST is not None :
            return self.manage_main(REQUEST)

#    def inlineEditForm(self,ob) :
#        if self.inline_edit :
#            if hasattr(ob.aq_base,'inlineEditItemForm') :
#                return ob.inlineEditItemForm(self.inline_edit,REQUEST)
#            return '<td colspan="%u" class="system-msg">  </td>' % len(self.inline_edit)
#        return ""
    
    def all_meta_types(self) :
        try :
            meta_types = self._subobjects_meta_types
        except AttributeError :
            meta_types = (self.meta_type,)

        return filter(lambda d,m = meta_types : d['name'] in m, self.aq_acquire('_product_meta_types') + Products.meta_types)

default__class_init__ (ObjectManager)
