__doc__ = """\
Project:MOFS
Start:  Tue Jul  1 15:16:05 MSK 2002
Author: Andrey Orlov (c) 2002
Version:$Id: l10n.py,v 1.13 2003/01/12 16:24:52 cray Exp $

Title:   
        MOFS / L10N

Description:

        Experemental localize support. Don't use without my
        products, please, it's only alpha!!


Licence:
        GPL
        
Warranty:
        There is no warranty of any kind, either expressed
        or implied 
        
TODO:        
        -    lang & encode 
               ;
        
        - Support for localized help;

"""
__version__ = "$Revision: 1.13 $"
# $Source: /var/lib/cvs/IIGFS/zope/Products/MOFS/l10n.py,v $
import zLOG

def _(x) : return x

import gettext,locale,os

def getL10n_decoder(file=__file__,prefix=None) :
    path = os.path.dirname(file)
    if prefix is None :
        prefix = os.path.basename(path)
    try :
	gt = gettext.translation('Zope.%s' % prefix, os.path.join(path,'locale'),[locale.setlocale(0)])
        def _ (x,f=gt) :
	    #xs = x
            try :
                x = gt.ugettext(x)
                # print "Locale",locale.getlocale(0),locale.getlocale(0)[1]
                return x.encode(locale.getlocale(0)[1])
            except (LookupError,TypeError,UnicodeError),msg :
		#print '',xs,msg
		try :
	                return gt.gettext(x)
		except UnicodeError :
			return x
        return _
    except IOError,msg :
        print 'Error',msg,'Zope.%s' % prefix,os.path.join(path,'locale'),locale.setlocale(0)
        return lambda x : x
    except :
	print 'Bam!'
        return lambda x : x

# edit here
def registerHelp(context, directory='help', clear=1 ) :
    l = locale.setlocale(0).split(".")
    try :
        lang = l[0]
    except IndexError :
	    lang = ''

    try :
	    encode = l[1]
    except IndexError :
	    encode = '' 

    for template in ('%(directory)s.%(lang)s.%(encode)s','%(directory)s.%(lang)s','%(directory)s') :
        ldname = template % vars()
        zLOG.LOG('MOFS',zLOG.DEBUG,_('Try to open %s') % os.path.join(_prefix, ldname, fname + '.dtml'))
        if os.path.exists(os.path.join(_prefix, ldname, fname + '.dtml')) :
    	    break
    
    return context.registerHelp(context, directory=directory, clear=clear )


import Globals
from App import Common

class HTMLFile(Globals.HTMLFile) :
    def __init__(self,name,_prefix=None, **kw):
        if _prefix is None: _prefix=SOFTWARE_HOME
        elif type(_prefix) is not type(''):
            _prefix=Common.package_home(_prefix)

	dname,fname = name.split('/',1)
        l = locale.setlocale(0).split(".")


        try :
            lang = l[0]
        except IndexError :
    	    lang = ''

        try :
    	    encode = l[1]
        except IndexError :
    	    encode = '' 


        for template in ('%(dname)s.%(lang)s.%(encode)s','%(dname)s.%(lang)s','%(dname)s') :
            ldname = template % vars()
            zLOG.LOG('MOFS',zLOG.DEBUG,_('Try to open %s') % os.path.join(_prefix, ldname, fname + '.dtml'))
            if os.path.exists(os.path.join(_prefix, ldname, fname + '.dtml')) :
		break

        apply(HTMLFile.inheritedAttribute('__init__'),(self,os.path.join(ldname,fname),_prefix),kw)

class DTMLFile(Globals.DTMLFile) :
    def __init__(self,name,_prefix=None, **kw):
        if _prefix is None: _prefix=SOFTWARE_HOME
        elif type(_prefix) is not type(''):
            _prefix=Common.package_home(_prefix)

	dname,fname = name.split('/',1)
        l = locale.setlocale(0).split(".")

        try :
            lang = l[0]
        except IndexError :
    	    lang = ''

        try :
    	    encode = l[1]
        except IndexError :
    	    encode = '' 

        for template in ('%(dname)s.%(lang)s.%(encode)s','%(dname)s.%(lang)s','%(dname)s') :
            ldname = template % vars()
            if os.path.exists(os.path.join(_prefix, ldname, fname + '.dtml')) :
		break

        apply(DTMLFile.inheritedAttribute('__init__'),(self,os.path.join(ldname,fname),_prefix),kw)


